// com.app.ibubble
// /Applications/iBubble.app/main.js


Plugins.load( "UIKit" );

// couleurs
var colorBlanc = [ 1 , 1 , 1 , 1 ];
var colorBleu = [ 0 , 0.1 , 1 , 1 ];
var colorCyan = [ 0 , 0.6823 , 0.9372 , 1 ];
var colorJaune = [ 1 , 0.9490 , 0 , 1 ];
var colorMagenta = [ 0.9254 , 0 , 0.5490 , 1 ];
//var colorNoir = [ 0 , 0 , 0 , 0 ];
var colorTrans = [ 0 , 0 , 0 , 0 ];
var colorOrange = [ 1 , 0.6588 , 0 , 1 ];
var colorRouge = [ 1 , 0.1 , 0 , 1 ];
var colorVert = [ 0 , 1 , 0.1 , 1 ];

// On to the standard set-up 
var window = new UIWindow( UIHardware.fullScreenApplicationContentRect );
window.setHidden( false );
window.orderFront();
window.makeKey();
window.backgroundColor = colorBlanc;

var mainView = new UIView();
window.setContentView( mainView );

mainView.backgroundColor = colorTrans;

var textTitle = [ "Finished !", "Over !", "Job done !", "Great !", "Well done !", "Good job !", "Nice !", 
  "Congratulations !", "Wow...", "Nice one !" ];

var textBody = [ "Had fun ? :-D", "You did it !", "Thanks for your help !", "Amazing !", "You're the one !", 
  "With compliments\nfrom your boss ! :)", "Impressive !", "Now get back to work !", "Thanks for playing !" ];

var wndWidth = ( window.bounds[ 2 ] - 1 );
var wndHeight = ( window.bounds[ 3 ] - 1 );
var sizeX = 38;
var halfX = ( sizeX / 2 );
var sizeY = 38;
var halfY = ( sizeY / 2 );
var maxX = Math.round( window.bounds[ 2 ] / sizeX ) + 2;
var maxY = Math.round( window.bounds[ 3 ] / sizeY ) + 2;
var maxBubbles = ( maxX * maxY );
var imgBubble = new Array( maxBubbles ); // table
var posBubble = new Array( maxY );
var isPoofed = new Array( maxBubbles ); // flag
var maxPoofed = 6; // unique poofed pictures
var imgPoofed = new Array( maxPoofed );
var maxSamples = 5;
var wavSample = new Array( maxSamples );
var countPoofed;
var realBubbles;
var totalBubbles;

// preload sounds
//for ( var i = 0 ; i <= maxSamples ; i++ )
//{
//  wavSample[ i ] = loadWav( Bundle.pathForResource( "bubble" + i + ".wav" ) );
//}

// preload and copy clean picture
var bubbleClean = Images.imageWithContentsOfFile( Bundle.pathForResource( "bubble_clean.png" ) , false );
for ( var i = 0 ; i <= maxBubbles ; i++ )
{
  imgBubble[ i ] = new UIImageView( bubbleClean );
  imgBubble[ i ].position = [ -sizeX , -sizeY ];
  mainView.addSubview( imgBubble[ i ] );
}

// create matrix array to store coordinates
for ( var i = 0 ; i <= maxY ; i++ )
{
  posBubble[ i ] = new Array( maxX );
}

// preload poofed pictures
for ( var i = 0 ; i <= maxPoofed ; i++ )
{
  imgPoofed[ i ] = Images.imageWithContentsOfFile( Bundle.pathForResource( "bubble" + i + ".png" ) , false );
}

// prepare alert sheet
var asRestart = new UIAlertSheet( "Finished !" , [ "Restart" ] , 1 );
asRestart.setDimsBackground( true );
asRestart.onButtonClicked = function( button )
{
  asRestart.dismiss( true );
  initBubbles();
}


function initBubbles()
{
  var isEven;
  var bigX;
  var bigY;
  var startX;
  var startY;
  var endX;
  var endY;
  var addX;
  var addY;
  var tempY;
  var posShiftX = getRandom( halfX );
  var posShiftY = getRandom( halfY );

  // hide all bubbles
  for ( var i = 0 ; i <= maxBubbles ; i++ )
  {
    imgBubble[ i ].position = [ -sizeX , -sizeY ];
  }

  // reset coordinates
  for ( var j = 0 ; j <= maxY ; j++ )
  {
    for ( var i = 0 ; i <= maxX ; i++ )
    {
      posBubble[ j ][ i ] = -1;
    }
  }

  // draw bubbles
  realBubbles = -1;
//  totalBubbles = -1;
  for ( var j = 0; j < maxY; j++ )
  {
    bigY = ( ( j * sizeY ) - posShiftY );
    if ( bigY > wndHeight )
    {
      break;
    }
    else
    {
      isEven = ( j / 2 == Math.round( j / 2 ) );
      for ( var i = 0 ; i < maxX ; i++ )
      {
        bigX = ( ( i * sizeX ) - posShiftX );
        if ( !isEven )
        {
          bigX -= halfX;
        }

        if ( bigX > wndWidth )
        {
          break;
        }
        else
        {
          realBubbles += 1;
          isPoofed[ realBubbles ] = false;
          imgBubble[ realBubbles ].setImage( bubbleClean );
          imgBubble[ realBubbles ].position = [ bigX , bigY ];

          // store coordinates
          startX = bigX;
          if ( bigX < 0 )
          {
            startX = 0;
          }

          startY = bigY;
          if ( bigY < 0 )
          {
            startY = 0;
          }

          posBubble[ Math.round( startY / sizeY ) ][ Math.round( startX / sizeX ) ] = realBubbles;

          // check if bubble can be poofed
//          if ( bigX > -halfX && bigX < ( wndWidth - halfX ) )
//          {
//            if ( bigY > -halfY && bigY < ( wndHeight - halfY ) )
//            {
//              totalBubbles += 1;
//            }
//          }
        }
      }
    }
  }

  totalBubbles = ( realBubbles - 9 );
  countPoofed = -1;
}


mainView.onMouseDown = function( event )
{
  setPoofed( Math.round( event.locationInWindow[ 0 ] / sizeX ), Math.round( event.locationInWindow[ 1 ] / sizeY ) );
}


mainView.onMouseDragged = function( event )
{
  setPoofed( Math.round( event.locationInWindow[ 0 ] / sizeX ), Math.round( event.locationInWindow[ 1 ] / sizeY ) );
}


function setPoofed( x, y )
{
  if (y < 0)
  {
    y = 0;
  }
  if (x < 0)
  {
    x = 0;
  }
  var idxBubble = posBubble[ y ][ x ];

  if ( !isPoofed[ idxBubble ] )
  {
    // play wavSample( getRandom( maxSamples ) );
    imgBubble[ idxBubble ].setImage( imgPoofed[ getRandom( maxPoofed ) ] );
    isPoofed[ idxBubble ] = true;
    countPoofed += 1;
    if (countPoofed == totalBubbles)
    {
      asRestart.setAlertSheetStyle( getRandom( 8 ) );
      asRestart.setTitle( textTitle[ getRandom( textTitle.length ) ] );
      asRestart.setBodyText( textBody[ getRandom( textBody.length ) ] );
      asRestart.popupAlertAnimated( true ); 
    }
  }
}


function getRandom( maxNumber )
{
  return ( Math.round( Math.random() * ( maxNumber - 1 ) ) );
}


initBubbles();

